<template>
  <v-btn
    class="studium-button"
    text
    :ripple="false"
    :class="selected ? 'primary--text' : 'secondary--text'"
    @click="select"
  >
    {{ text }}

    <v-icon v-if="selected" class="sort-icon" :class="descending ? 'sort-icon--descending' : ''">
      mdi-chevron-up
    </v-icon>
  </v-btn>
</template>

<script lang="ts">
import { computed, defineComponent } from '@nuxtjs/composition-api'
import { useVModel } from '@vueuse/core'

export default defineComponent({
  props: {
    // Property of the file that this button will sort
    property: {
      type: String,
      required: true,
    },

    // Text of the button
    text: {
      type: String,
      required: true,
    },

    // Selected sorting option
    sortSelected: {
      type: Object,
      required: true,
    },

    defaultOrder: {
      type: String,
      required: true,
    },
  },
  setup(props, { emit }) {
    // VModel  value
    const sortSelected = useVModel(props, 'sortSelected', emit)

    // If the sort button is selected
    const selected = computed(() => props.property === sortSelected.value?.property)

    // If the sort order is ascending
    const ascending = computed(() => sortSelected.value?.order === 'asc')

    // If the sort order is descending
    const descending = computed(() => sortSelected.value?.order === 'desc')

    // Update the selected sorting option
    function select() {
      // If the sorting option is already selected,
      // switch the order from asc to desc or vice versa
      if (sortSelected.value.property === props.property) {
        sortSelected.value.order = ascending.value ? 'desc' : 'asc'
      } else {
        // Otherwise, select the sorting option
        sortSelected.value.property = props.property
        sortSelected.value.order = props.defaultOrder
      }
    }

    return {
      selected,
      ascending,
      descending,
      select,
    }
  },
})
</script>

<style lang="scss" scoped>
.sort {
  &-icon {
    transition: transform 0.2s linear, opacity;
    transform: rotate(0deg);
    opacity: 1;

    &--descending {
      transform: rotate(180deg);
    }
  }
}
</style>
